
api.colors = {
  ok = 0x00cc00ff,
  warn = 0xff9900ff,
  white = 0xffffffff,
  black = 0x00000000,
}

api.ups = function()
  return 60
end

api.every = function(seconds)
  local api = api
  return api.tick() % api.ups() == api.id() % api.ups()
end

api.is_item = function(name)
  return api.items[name] ~= nil
end

api.is_warehouse = function(id)
  return api.entity_type(id) == "warehouse"
end

api.is_monorail = function(id)
  return api.entity_type(id) == "monorail_tower"
end

api.adjacent_warehouse = function()
  local api = api
  for i,entity in ipairs(api.entities_adjacent()) do
    if api.is_warehouse(entity) then
      return entity
    end
  end
  return 0
end

api.adjacent_monorail = function()
  local api = api
  for i,entity in ipairs(api.entities_adjacent()) do
    if api.is_monorail(entity) then
      return entity
    end
  end
  return 0
end

table.count = function(tbl)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  for _ in ipairs(T) do count = count + 1 end
  return count
end

(function()
  local function deepFreeze(target)
    -- Shallow freeze the table
    table.freeze(target)

    -- Check each key of the table and freeze it if it's a table
    for _, val in target do
      -- Make sure the val isn't frozen; if it already is, an error will occur
      if type(val) == "table" and table.isfrozen(val) == false then
        deepFreeze(val)
      end
    end
  end
  deepFreeze(api)
end)()
