gui = {
  title = "Wifi to LAN",
  description = "Relay signals from Wifi to LAN",
  fields = {
    filter = {
      title = "Filter Signal",
      type = "string",
      description = "Limit to a single signal.",
      default = "",
      order = "a",
    },
    log = {
      title = "Log Activity",
      type = "boolean",
      description = "Periodically log activity to console",
      default = true,
      order = "c",
    },
  }
}

function main()
  local logging = api.every(1)
  local filter = api.gui_fields().filter

  if logging and #filter == 0 then
    print("relaying all signals")
  end

  if logging and #filter > 0 then
    print("relaying signal: " .. filter)
  end

  for key,val in pairs(api.wifi_signals()) do
    if #filter == 0 or key == filter then
      api.lan_send(key,val)
    end
  end
end
